if ('undefined' == typeof SothinkFlashDownloader) {
	SothinkFlashDownloader = {};
}
SothinkFlashDownloader.objArray = [];
SothinkFlashDownloader.Tree = {
	swfobj: function(name, size, date, checked, url, alive) {
		this.name = name;
		this.date = date;
		this.size = size;
		this.checked = checked;
		this.url = url;
		this.alive = alive;
	},
	localfromfilepath: function(filepath) {
		if (filepath.substring(0, 8) == "file:///") {
			var temp = filepath.replace("file:///", "");
			while (temp.lastIndexOf("/") > 0) {
				temp = temp.replace("/", "\\");
			}
			while (temp.lastIndexOf("\%") > 0) {
				temp = temp.replace("%20", " ");
			}
			return (temp);
		};

		return null;
	},

	shortDateFormat: function(longDateFormat) {
		var curmonth = longDateFormat.getMonth() + 1;
		var curdate = longDateFormat.getDate();
		var curyear = longDateFormat.getYear() + 1900;
		var curhour = longDateFormat.getHours();
		var curminute = longDateFormat.getMinutes();
		var cursecond = longDateFormat.getSeconds();

		var shortformat = (curmonth < 10 ? "0" + curmonth: curmonth) + "/" + (curdate < 10 ? "0" + curdate: curdate) + "/" + (curyear < 10 ? "0" + curyear: curyear) + "  " + (curhour < 10 ? (curhour > 0 ? "0" + curhour: "00") : curhour) + ":" + (curminute < 10 ? (curminute > 0 ? "0" + curminute: "00") : curminute) + ":" + (cursecond < 10 ? (cursecond > 0 ? "0" + cursecond: "00") : cursecond);
		return shortformat;
	},
	reflectTreeBuild: function() {
		SothinkFlashDownloader.objArray = [];
		if (SothinkFlashDownloader.Parse.validateURLs.length == 0) return;
		for (var i = SothinkFlashDownloader.Parse.validateURLs.length - 1; i >= 0; i--) {
			var path = SothinkFlashDownloader.Parse.validateURLs[i];

			if (path.substring(0, 8) == "file:///") {
				try {
					var file = new File(SothinkFlashDownloader.Tree.localfromfilepath(path));
					if (file.exists()) {
						SothinkFlashDownloader.objArray.push(new SothinkFlashDownloader.Tree.swfobj(file.leaf(), file.size(), SothinkFlashDownloader.Tree.shortDateFormat(new Date(file.dateModified())), false, path, true));
					} else {
						SothinkFlashDownloader.objArray.push(new SothinkFlashDownloader.Tree.swfobj(path.substring(path.lastIndexOf("/") + 1), "?", "?", false, path, false));
					}
				} catch(e) {
					alert(e);
				}
			}
			
			if (path.substring(0, 7) == "http://") {
				var myurl = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURL), afilename;
				myurl.spec = path;
				if (SothinkFlashDownloader.Parse.testContain(myurl.fileName, ".swf")) {
					afilename = myurl.fileName;
				} else {
					afilename = myurl.fileName + '.swf';
					//afilename = myurl.fileName;
				}
				SothinkFlashDownloader.objArray.unshift(new SothinkFlashDownloader.Tree.swfobj(afilename, "?", "?", false, path, null));
			}
		}
		document.getElementById('my-tree').focus();
		SothinkFlashDownloader.Cache.testcache();
	},
	setView: function() {
		SothinkFlashDownloader.treeView.rowCount = SothinkFlashDownloader.objArray.length;
		document.getElementById('my-tree').view = SothinkFlashDownloader.treeView;
	},
	outputSize: function(filesize) {
		const kbyte = 1024;
		const kcomma = 1e3;
		const ten = 10;
		const one = 1;

		if (filesize == "?") {
			return filesize;
		} else if (filesize >= 0) {
			var temp = (Math.round(filesize / kbyte * ten)) / 10;
			if (temp <= 0.1) {
				return "0.1K";
			} else if (temp > 0.1 && temp < kcomma) {
				return temp + "K";
			} else {
				//process the most complext situation
				var part1 = Math.floor(temp);
				var part2 = Math.round(temp % one * 10);
				var result = (part2 == 0 ? "K": "." + part2 + "K");

				while (part1 > 0) {
					var part3 = part1 % kcomma;
					part1 = Math.floor(part1 / kcomma);
					if (part1 == 0) {
						result = part3 + result;
					} else {
						var parttemp = part3 >= ten * ten ? part3: (part3 >= ten ? "0" + part3: "00" + part3);
						result = "," + parttemp + result;
					}
				}
				return result;
			}
		}
	}
};

SothinkFlashDownloader.treeView = {
	getCellText: function(row, col) {
		if (SothinkFlashDownloader.objArray[row]) {
			return SothinkFlashDownloader.objArray[row][col.id];
		}
	},
	getImageSrc: function(row, col) {
		if (SothinkFlashDownloader.objArray[row]) {
			if (col.id == 'name') {
				if ( !! SothinkFlashDownloader.objArray[row]['alive']) {
					return 'chrome://swfcatcher/skin/local.ico';
				} else if (!SothinkFlashDownloader.objArray[row]['alive']) {
					return 'chrome://swfcatcher/skin/download.ico';
				} else {
					return 'chrome://swfcatcher/skin/download.ico';
				}
			}
		}
	},
	setTree: function(treebox) {
		this.treebox = treebox;
	},
	isContainer: function(row) {
		return false;
	},
	isSeparator: function(row) {
		return false;
	},
	isSorted: function() {
		return false;
	},
	getLevel: function(row) {
		return 0;
	},
	getRowProperties: function(row, props) {},
	getCellProperties: function(row, col, props) {},
	getColumnProperties: function(colid, col, props) {}
}